milkyway/urls.py
from django.conf.urls import url
from . import views
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^(?P<property_id>[0-9]+)/$', views.detail, name='detail'),
#    url(r'^detail/$', views.detail, name='detail'),
    url(r'^(?P<property_id>[0-9]+)/gallery$', views.gallery, name='gallery'),
    url(r'^mapsearch/$', views.map_search, name='mapsearch'),

    url(r'^custom_search/$', views.custom_search, name='custom_search'),
    url(r'^sell/$', views.sell, name='sell'),
    url(r'^buy/$', views.buy, name='buy'),
#    url(r'^rent/$', views.rent, name='rent'),
    url(r'^contact_us/$', views.contact_us, name='contact_us'),
    url(r'^more/(?P<pid>[0-9]+)/$', views.plot, name='see_more'),
    url(r'^mindex', views.mindex,name='mindex')


]
if settings.DEBUG:
    urlpatterns+= static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

sarober/urls.py
from django.conf.urls import include,url
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'',include('milkyway.urls')),
    url(r'^search/',include('haystack.urls')),
]

milkyway/models.py
from __future__ import unicode_literals

from decimal import Decimal
from django.db import models
import os

# Create your models here.

TYPES=(
    ('building','building'),
    ('land','land'),
    ('rentroom','rentroom'),
#    ('plot','plot'),
#    ('housing','housing')
#   ('office','office')
#   ('plot','plot')
)
FOR=(
    ('sale','sale'),
    ('rent','rent'),
)

class Position(models.Model):
    lat         = models.FloatField(null=True,blank=True,default=0.0)
    lng         = models.FloatField(null=True,blank=True,default=0.0)

    def get_position(self):
        return [self.lat,self.lng]
    def __str__(self):
        return str(self.lat)+ ','+str(self.lng)


class Location(models.Model):
    zone        = models.CharField(max_length=20)
    district    = models.CharField(max_length=20)
    city        = models.CharField(max_length=20,null=True)
    locality    = models.CharField(max_length=20)
    position    = models.OneToOneField('Position')


    def __str__(self):
        return str(self.city)+', '+str(self.locality)



def get_img_path(instance,filename):
    return os.path.join('images/property_img', filename)


class Image(models.Model):
    imgfile     = models.ImageField(upload_to= get_img_path )

class Gallery(models.Model):
    imgfile     = models.ImageField(upload_to= get_img_path )
    for_estate  = models.ForeignKey('Estate',null=True,blank=True)



class Features(models.Model):
    title       = models.CharField(max_length=16,null=True)
    detail      = models.CharField(max_length=128,null=True)

    for_estate  = models.ForeignKey('Estate',null=True,blank=True)

    def __str__(self):
        return self.title+' '+ self.detail

# Purpose
# Number of Rooms
# Number of Storey

class Owner(models.Model):
    name        = models.CharField(max_length=64)
    address     = models.CharField(max_length=64,blank=True)
    profession  = models.CharField(max_length=64,blank=True)
    email       = models.EmailField(max_length=64,blank=True)
    phone       = models.CharField(max_length=64)
    img         = models.ForeignKey('Image')

    def __str__(self):
        return self.name

class Estate(models.Model):

    title       = models.CharField(max_length=32,null=True)
    ptype       = models.CharField(choices=TYPES,max_length=16)
    location    = models.ForeignKey('Location')
    price       = models.DecimalField(max_digits=10,decimal_places=0)
#    price_in_words= models.CharField(max_length=32,null=True,blank=True)
    description = models.TextField()
    is_sold     = models.BooleanField(default=False)
    is_for      = models.CharField(choices=FOR,max_length=16,default='sale')
    area        = models.CharField(max_length=32,null=True)
    img         = models.ForeignKey('Image')
    owner       = models.ForeignKey('Owner')

    position    = models.OneToOneField('Position')
    inplot      = models.ForeignKey('Plot',null=True,blank=True)
    inapartment = models.ForeignKey('Apartment',null=True,blank=True)
    inhousing   = models.ForeignKey('Housing',null=True,blank=True)

    def sold(self):
        is_sold = True

    def __str__(self):
        return 'RealEstate '+str(self.id)

class Plot(models.Model):
    title       = models.CharField(max_length=20,blank=True,null=True)
    plan_img    = models.ForeignKey('Image')
    def __str__(self):
        return 'Plot '+self.title

class Housing(models.Model):
    title       = models.CharField(max_length=20,blank=True,null=True)
    plan_img    = models.ForeignKey('Image')
    storey      = models.IntegerField(default=1)
    bhk         = models.IntegerField(default=1)

    def __str__(self):
        return 'Housing '+self.title

class Apartment(models.Model):
    title       = models.CharField(max_length=20,blank=True,null=True)
    plan_img    = models.ForeignKey('Image')
    bhk         = models.IntegerField(default=1)

    def __str__(self):
        return 'Apartment '+self.title

milkyway/forms.py
from django import forms
from haystack.forms import SearchForm

class CustomSearchForm(SearchForm):
    prop_type = forms.ChoiceField(choices= (
        ('all','all'),
        ('land', 'Land'),
        ('building', 'Building'),
        ('plot', 'Plot'),
        ('room', 'Room')
    ))
    def search(self):
        # First, store the SearchQuerySet received from other processing.
        sqs = super(CustomSearchForm, self).search()

        if not self.is_valid():
            return self.no_query_found()

        return sqs

milkyway/views.py
from django.shortcuts import render

from django.http import HttpResponse
from django.contrib import messages
from milkyway.models import *

from django.core.mail import get_connection, EmailMultiAlternatives, send_mail
from django.conf import settings
from milkyway.forms import CustomSearchForm
from django.core import serializers
from django.core.paginator import Paginator, EmptyPage, PageNotAnInteger
from haystack.views import basic_search
from haystack.query import EmptySearchQuerySet

# Create your views here.
RESULTS_PER_PAGE = getattr(settings, 'HAYSTACK_SEARCH_RESULTS_PER_PAGE', 10)

def plot(pid):
    p=Plot.objects.get(pk=pid)
    e=Estate.objects.filter(inplot=p).all()
    context={'pestate':e}
    return context

def housing(pid):
    p=Housing.objects.get(pk=pid)
    e=Estate.objects.filter(inhousing=p).all()
    context={'hestate':e}
    return context

def apartment(pid):
    p=Apartment.objects.get(pk=pid)
    e=Estate.objects.filter(inapartment=p).all()
    context={'aestate':e}
    return context


## our index page

def index(request):
    estate=Estate.objects.all()[:9]
#   take just 3 properties for index
    hot = Plot.objects.all()[0]  # get a hot aggrigated property
    items=plot(hot.id)           # get all estates in hot property

    latest={'estate':estate}
    latest['hot']=hot
    latest['form'] = CustomSearchForm
    latest.update(items)

    return render(request,'milkyway/index.html', latest)


def buy(request):
    estate=Estate.objects.all()
    paginator = Paginator(estate,RESULTS_PER_PAGE)
    page = paginator.page(int(request.GET.get('page', 1)))

    return render(request,'milkyway/properties.html',{'estate':page})



def mindex(request):
    estate=Estate.objects.all()[:]
#   take just 3 properties for index
    latest={'estate':estate}
    latest['form'] = CustomSearchForm

    return render(request,'milkyway/mindex.html', latest)


def see_more(request):
    prop=Estate.objects.all()
    content={'prop':prop}

    return render(request,'milkyway/seeall.html', content)

def queryset_gen(search_qs):
    for item in search_qs:
        yield item.object  # This is the line that gets the model instance out of the Search object

def map_search(request):

    query = ''
    results = EmptySearchQuerySet()
    prop_type=''

    if request.GET.get('q'):
        form = CustomSearchForm(request.GET, load_all=True)

        if form.is_valid():
            query = form.cleaned_data['q']
            prop_type = form.cleaned_data['prop_type']
            results = form.search()
    else:
        form = CustomSearchForm(load_all=True)
    locations=[]
    result=queryset_gen(results)
    for x in result:
        locations.append(x)

    print(locations)
    context={'locations':locations ,'ptype':prop_type}
    if locations:
        context['center']=locations[0]
    else:
        return HttpResponse("No Properties Found!!!")

    return render(request,'milkyway/mapsearch.html',context)

def detail(request,property_id):

    prop=Estate.objects.get(id=property_id)

    cord={'lat':prop.location.position.lat,'lng':prop.location.position.lng}
    cord['prop']=prop
    print(cord)
    return render(request,'milkyway/detail.html',cord)



def sell(request):
    if request.method== 'POST':
        name=request.POST['owner']
        num=request.POST['num']
        address=request.POST['address']
        mailaddress=request.POST['email']
        location =request.POST['location']
        price = request.POST['price']
        area=request.POST['area']
        isfor=request.POST['ptype']
        about=request.POST['about']

        if name=='' or num=='' or name==' ' or num==' ':
            messages.warning(request,'Please recheck form again and try !!!')


        subject,seller,to='Sell Property','mail@sarober.com','manesarober@gmail.com'
        html_content='<h2>New Propery '+ isfor +' request:</h2> <p>owner:'+name+'<br>'+'phone num:'+num+'<br>'+ 'address:'+address+'<br>'+ 'mailaddress:'+mailaddress+'<br>'+ 'location:'+location+'<br>'+ 'price:'+price+'<br>'+ 'area:'+area+'<br>'+ 'description:'+about+'</p>'

        email=EmailMultiAlternatives(subject,'''I wanna sell this propery''',seller,[to,'bb.bindash35@gmail.com'])
        email.attach_alternative(html_content,'text/html')
        email.send()
#        send_mail(subject,description,'mail@sarober.com',['manesarober@gmail.com'], fail_silently=False,)

        context="Success !! Your sell request is send. We will Contact you as soon as possibe."
        messages.success(request,context)
    return render(request,'milkyway/sell.html')

def contact_us(request):
    if request.method== 'POST':
        name=request.POST['owner']
        num=request.POST['num']
        address=request.POST['address']
        mailaddress=request.POST['email']
        about=request.POST['about']

        if name=='' or num=='' or name==' ' or num==' ':
            messages.warning(request,'Please recheck form again and try !!!')


        subject,seller,to='Message','mail@sarober.com','manesarober@gmail.com'
        html_content='<h2>New Message request:</h2> <p>Name: '+name+'<br>'+'phone num:'+num+'<br>'+ 'address:'+address+'<br>'+ 'mailaddress:'+mailaddress+'<br>'+ 'description:'+description+'</p>'

        email=EmailMultiAlternatives(subject,'''I wanna sell this propery''',seller,[to,'bb.bindash35@gmail.com'])
        email.attach_alternative(html_content,'text/html')
        email.send()
#        send_mail(subject,description,'mail@sarober.com',['manesarober@gmail.com'], fail_silently=False,)

        messages.success(request,'Thanks For Your Message')
    return render(request,'milkyway/contactus.html')




def gallery(request,property_id):
    return HttpResponse("You're looking at gallery %s" % property_id)


def custom_search(request):
    query = ''
    results = EmptySearchQuerySet()
    prop_type=''

    if request.GET.get('q'):
        form = CustomSearchForm(request.GET, load_all=True)

        if form.is_valid():
            query = form.cleaned_data['q']
            prop_type = form.cleaned_data['prop_type']
            results = form.search()
    else:
        form = CustomSearchForm(load_all=True)

    print (query)

    paginator = Paginator(results,RESULTS_PER_PAGE)

    try:
        page = paginator.page(int(request.GET.get('page', 1)))
    except InvalidPage:
        raise HttpResponse("No such page of results!")

    context = {
        'form': form,
        'page': page,
        'paginator': paginator,
        'query': query,
        'suggestion': None,
        'prop_type':prop_type,
    }

    if results.query.backend.include_spelling:
        context['suggestion'] = form.get_suggestion()


    return render(request,'milkyway/searchresults.html', context)

templates/milkyway/apartmentbox.html
{% load staticfiles %}
<div class="col-md-4 item-block animate-box" data-animate-effect="fadein">
    <div class="fh5co-property">
            <figure>
                    <img src="{{ hot.plan_img.imgfile.url }}" alt="images" class="img-responsive"></a>
                    <span class="tag">{{hot.bhk}} BHK</span>
                    <span class="price-tag"><strong>Housing<strong></span>

            </figure>
            <div class="fh5co-property-innter">
                    <h3>{{hot.title}}</h3>
            </div>
            <div class='row'>
            {% for i in aestate %}
                <div class="col-md-3">
                    <a href="{% url 'detail'  property_id=i.id %}"><img src="{{ e.plan_img.imgfile.url }}" alt="images" class="img-responsive"></a>
                </div>
            {% endfor %}
            </div>
    </div>
</div>

templates/milkyway/buildingbox.html
{% load staticfiles %}
<div class="col-md-4 item-block animate-box" data-animate-effect="fadeIn">
    <div class="fh5co-property">
            <figure>
                    <a href="{% url 'detail'  property_id=e.id %}"><img style="width:100%" src="{{ e.img.imgfile.url }}" alt="images" class="img-responsive"></a>
                    <span class="tag">Building For {{e.is_for}}</span>
                    <span class="price-tag"><strong>NRs.{{e.price}}<strong></span>
            </figure>
            <div class="fh5co-property-innter">
                    <h3><a href="{% url 'detail' property_id=e.id %}">In {{e.location}}</a></h3>
            </div>
        <p class="fh5co-property-specification">
            <span><strong>{{e.area}}</strong> Sq Ft</span>  <span><strong>3</strong> Storey</span> <span><strong>3</strong> BHK</span>
        </p>
    </div>
</div>

templates/milkyway/detail.html
{% extends "milkyway/base.html" %}
{% load staticfiles %}
            {% block nav_menu %}
                <li><a href="{% url 'buy'%}">Buy</a></li>
                <li><a href="{% url 'sell' %}">Sell/Rent</a></li>
                <!--li><a href="properties.html">Properties</a></li-->
                <li class="cta" ><a href="#">Engineering Solutions</a></li>
                <!--li class="call"><a href="tel://123456789"><i class="icon-phone"></i> +1 123 456 789</a></li-->
                <li class="cta"><a href="{% url 'contact_us'%}">Contact us</a></li>
            {% endblock %}

{% block main_content %}

<div class="fh5co-page-title" style="background-image: url({% static 'images/slide_6.jpg' %});">
        <div class="overlay"></div>
        <div class="container">
                <div class="row">
                        <div class="col-md-12 animate-box">
                                <h1>Property in <span class="colored">detail</span></h1>
                        </div>
                </div>
        </div>
</div>

<div class="fh5co-contact animate-box">
        <div class="container">
                <div class="row">
                        <div class="col-md-4">
                                <h3 class="text-info">Owner Info.</h3>
                                <ul class="contact-info">
        <li>
        <figure>
            <img src="{{prop.owner.img.imgfile.url}}" alt="Free Website Templates FreeHTML5.co" class="img-responsive">
        </figure>
        </li>
        <li><h4 class="text-primary">{{prop.owner.name}}</h4></li>
        <li><i class="icon-map"></i> {{prop.owner.address}}</li>
        <li><i class="icon-phone"></i>+977 {{prop.owner.phone}}</li>
        <li><i class="icon-envelope"></i>{{prop.owner.email}}</li>

                                </ul>

    <div id ="search" class="fh5co-contact animate-box">

            <form id="search-form" method ="get" action="{% url 'custom_search'%}">

                        <div class="form-group">
                        <input class="form-control" name="q" style="background: rgba(0, 0, 0, 0.15); max-width:80%; margin:25px 10%;" type="text" id="q_id" name="q" placeholder="Search With <Location>"  autocomplete="off"/>
                    </div>
                <select class="dropdown" name="prop_type" id="id_prop_type" style="margin:5px 10%; width:80%;">
                    <option selected="selected" value="all">Select Property Type</option>
                    <option value="land">Land</option>
                    <option value="building">Building</option>
                    <option value="room">Flat</option>
                </select>
                        <div class="form-group">
                        <a href="javascript:void(0)" onclick="simple_search()" />
                        <input type="button" id="submit" style="margin:5px 10%; width:80%;" class="btn btn-search btn-info" name="submit_search" value="Search"/>
                        </div>
                        <div class="form-group">
                        <a href="javascript:void(0)" onclick="map_search()" />
                        <input type="button" id="submit" style="margin:5px 10%; width:80%;" class="btn btn-search btn-warning" name="submit_search" value="Map Search"/>
                        </div>


</div>
    </div>



    <div class="col-md-7 col-md-push-1 col-sm-12 col-sm-push-0 col-xs-12 col-xs-push-0">
    <div class="item-block animate-box" data-animate-effect="fadeIn">
                                <div class="fh5co-property">
                                        <figure>
                                                <img src="{{prop.img.imgfile.url}}" alt="Img" class="img-responsive">
                                                <span  class="tag">For Sale</span>
        <span class="price-tag"><strong>{{prop.price}}<strong>/Aana</span>
                                        </figure>
                                        <div class="fh5co-property-innter">
                                                <h3 class="text-muted">{{prop.title}} at {{prop.location}}</h3>
                                                <ul class="price-status">        <!--features-->
                {% for x in prop.features_set.all %}
                <li>
                                <span class="price">{{x.title}}<strong>{{x.detail}}</strong></span>
                </li>
                {% endfor %}
                        </ul>
                        <p>{{prop.description}}</p>
                </div>
                <p class="fh5co-property-specification">
                        <span><strong>{{prop.area}}</strong> Aana</span>  <span><strong>3</strong> Beds</span>  <span><strong>3.5</strong> Baths</span>  <span><strong>2</strong> Garages</span>
                </p>

        <div id="map" ></div>
                                </div>
                        </div>

                        </div>
                </div>
        </div>
</div>

{% endblock %}

{% block scripts %}
    <script>

    function simple_search() {
        var search_data = $('#search-form').serialize();
        var root="http://localhost:8000/"
        window.location = root+"custom_search?"+search_data;
    }

    function map_search() {
        var search_data = $('#search-form').serialize();
        var root="http://localhost:8000/"
        window.location = root+"mapsearch?"+search_data;
    }

var google;

function init() {
    // Basic options for a simple Google Map
    // For more options see: https://developers.google.com/maps/documentation/javascript/reference#MapOptions
    // var myLatlng = new google.maps.LatLng(40.71751, -73.990922)° N, ;
    var myLatlng = new google.maps.LatLng({{lat}},{{lng}});
    // 39.399872
    // -8.224454

    var mapOptions = {
        // How zoomed in you want the map to start at (always required)
        zoom:12,

        // The latitude and longitude to center the map (always required)
        center: myLatlng,

        // How you would like to style the map.
        scrollwheel: false,
        styles: [{"featureType":"administrative.land_parcel","elementType":"all","stylers":[{"visibility":"off"}]},{"featureType":"landscape.man_made","elementType":"all","stylers":[{"visibility":"off"}]},{"featureType":"poi","elementType":"labels","stylers":[{"visibility":"off"}]},{"featureType":"road","elementType":"labels","stylers":[{"visibility":"simplified"},{"lightness":20}]},{"featureType":"road.highway","elementType":"geometry","stylers":[{"hue":"#f49935"}]},{"featureType":"road.highway","elementType":"labels","stylers":[{"visibility":"simplified"}]},{"featureType":"road.arterial","elementType":"geometry","stylers":[{"hue":"#fad959"}]},{"featureType":"road.arterial","elementType":"labels","stylers":[{"visibility":"off"}]},{"featureType":"road.local","elementType":"geometry","stylers":[{"visibility":"simplified"}]},{"featureType":"road.local","elementType":"labels","stylers":[{"visibility":"simplified"}]},{"featureType":"transit","elementType":"all","stylers":[{"visibility":"off"}]},{"featureType":"water","elementType":"all","stylers":[{"hue":"#a1cdfc"},{"saturation":30},{"lightness":49}]}]
    };



    // Get the HTML DOM element that will contain your map
    // We are using a div with id="map" seen below in the <body>
    var mapElement = document.getElementById('map');

    // Create the Google Map using out element and options defined above
    var map = new google.maps.Map(mapElement, mapOptions);

    var addresses = ['Kathmandu'];

    for (var x = 0; x < addresses.length; x++) {
        $.getJSON('http://maps.googleapis.com/maps/api/geocode/json?address='+addresses[x]+'&sensor=false', null, function (data) {
            var p = data.results[0].geometry.location;
            var latlng = new google.maps.LatLng({{prop.position.lat}}, {{prop.position.lng}});
            new google.maps.Marker({
                position: latlng,
                map: map,
                icon: 'http://localhost:8000/static/images/homo.png'
            });

        });
    }

}
google.maps.event.addDomListener(window, 'load', init);
        </script>

    <script async defer
        src="https://maps.googleapis.com/maps/api/js?key=AIzaSyA5hoIozQlhqeLzU0w9ksjnS7wj3k6ExNU&callback=init">
    </script>
{% endblock %}

templates/milkyway/flatbox.html
{% load staticfiles %}
<div class="col-md-4 item-block animate-box" data-animate-effect="fadeIn">
    <div class="fh5co-property">
            <figure>
                    <a href="{% url 'detail'  property_id=e.id %}"><img src="{{ e.img.imgfile.url }}" alt="images" class="img-responsive"></a>
                    <span class="tag">Flat For Sale</span>
                    <span class="price-tag"><strong>NRs.{{e.price}}<strong>/month</span>
            </figure>
            <div class="fh5co-property-innter">
                    <h3><a href="{% url 'detail'  property_id=e.id %}">In {{e.location}}</a></h3>
            </div>
        <p class="fh5co-property-specification">
                <span><strong>{{e.area}}</strong> Sq Ft</span>  <span><strong>3</strong> Beds</span>  <span><strong>3.5</strong> Baths</span>  <span><strong>2</strong> Parking</span>
        </p>
    </div>
</div>

templates/milkyway/mapsearch.html
{% extends "milkyway/base.html" %}
{% load staticfiles %}
            {% block nav_menu %}
                <li><a href="{% url 'buy'%}">Buy</a></li>
                <li><a href="{% url 'sell' %}">Sell/Rent</a></li>
                <!--li><a href="properties.html">Properties</a></li-->
                <li class="cta" ><a href="{%static 'sell.html'%}">Engineering Solutions</a></li>
                <!--li class="call"><a href="tel://123456789"><i class="icon-phone"></i> +1 123 456 789</a></li-->
                <li class="cta"><a href="{% url 'contact_us'%}">Contact us</a></li>
            {% endblock %}

{% block main_content %}



    <div class="fh5co-page-title" style="background-image: url({% static 'images/slide_6.jpg' %});">
            <div class="overlay"></div>
            <div class="container">
                    <div class="row">
                            <div class="col-md-12 animate-box">
                                    <h1>Map Search <span class="colored">Results</span></h1>
                            </div>
                    </div>
            </div>
    </div>

    <div id="map" class="animate-box" data-animate-effect="fadeIn"></div>

    <div id ="search" class="fh5co-contact animate-box">
            <div class="search">
            <div class="container">
            <form id="search-form" method ="get" action="{% url 'custom_search'%}">
    <div class="col-md-4">
            <div class="form-group">
            <input name="q" class="form-control" style="background: rgba(0, 0, 0, 0.15)" type="text" id="q_id" name="q" placeholder="Search With <Location>"  autocomplete="off"/>
    </div>
    </div>
    <div class="col-md-4">
            <select name="prop_type" class="dropdown" id="id_prop_type">
                    <option selected="selected" value="all">Select Property Type</option>
                    <option value="land">Land</option>
                    <option value="building">Building</option>
                    <option value="room">Flat</option>
            </select>
    </div>
    <div class="col-md-4">
            <div class="form-group">
                        <a href="javascript:void(0)" onclick="simple_search()" />
            <input type="button" id="submit" class="btn btn-search btn-info" name="submit_search" value="Search"/>
                        <a href="javascript:void(0)" onclick="map_search()" />
            <input type="button" id="submit" class="btn btn-search btn-warning" name="submit_search" value="Map Search"/>
    </div>
    </div>

</div>
</div>
    <form>
</div>


{% endblock %}

{% block scripts %}
    <script>
    function simple_search() {
        var search_data = $('#search-form').serialize();
        var root="http://localhost:8000/";
        window.location = root+"custom_search?"+search_data;
    }

    function map_search() {
        var search_data = $('#search-form').serialize();
        window.location = "?"+search_data;
    }
var google;
function addInfoWindow(marker, message) {

            var infoWindow = new google.maps.InfoWindow({
                content: message
            });

            google.maps.event.addListener(marker, 'click', function () {
                infoWindow.open(map, marker);
            });
        }

function init() {
    // Basic options for a simple Google Map
    // For more options see: https://developers.google.com/maps/documentation/javascript/reference#MapOptions
    // var myLatlng = new google.maps.LatLng(40.71751, -73.990922)° N, ;
    var myLatlng = new google.maps.LatLng({{center.position.lat}},{{center.position.lng}});
    // 39.399872
    // -8.224454

    var mapOptions = {
        // How zoomed in you want the map to start at (always required)
        zoom:12,

        // The latitude and longitude to center the map (always required)
        center: myLatlng,

        // How you would like to style the map.
        scrollwheel: false,
        styles: [{"featureType":"administrative.land_parcel","elementType":"all","stylers":[{"visibility":"off"}]},{"featureType":"landscape.man_made","elementType":"all","stylers":[{"visibility":"off"}]},{"featureType":"poi","elementType":"labels","stylers":[{"visibility":"off"}]},{"featureType":"road","elementType":"labels","stylers":[{"visibility":"simplified"},{"lightness":20}]},{"featureType":"road.highway","elementType":"geometry","stylers":[{"hue":"#f49935"}]},{"featureType":"road.highway","elementType":"labels","stylers":[{"visibility":"simplified"}]},{"featureType":"road.arterial","elementType":"geometry","stylers":[{"hue":"#fad959"}]},{"featureType":"road.arterial","elementType":"labels","stylers":[{"visibility":"off"}]},{"featureType":"road.local","elementType":"geometry","stylers":[{"visibility":"simplified"}]},{"featureType":"road.local","elementType":"labels","stylers":[{"visibility":"simplified"}]},{"featureType":"transit","elementType":"all","stylers":[{"visibility":"off"}]},{"featureType":"water","elementType":"all","stylers":[{"hue":"#a1cdfc"},{"saturation":30},{"lightness":49}]}]
    };



    // Get the HTML DOM element that will contain your map
    // We are using a div with id="map" seen below in the <body>
    var mapElement = document.getElementById('map');

    // Create the Google Map using out element and options defined above
    var map = new google.maps.Map(mapElement, mapOptions);


    {% for y in locations %}
        {% for x in y.estate_set.all %}
            var latlng = new google.maps.LatLng({{x.position.lat}}, {{x.position.lng}});
            var marker= new google.maps.Marker({
                position: latlng,
                map: map,
                icon: 'http://localhost:8000/static/images/homo.png'
            });
        var contentString = '<img src="{{x.img.imgfile.url}}" style="width:158px;height:100px;" alt="img" class="img-responsive">' +
                            '<ul class="list-group"><li><h4 class="list-group-item list-group-item-success">{{x.title}}</h4></li>' +
                            '<li class="list-group-item">{{x.area}}</li>'+
                            '<li class="list-group-item list-group-item-info">Rs {{x.price}}</li>'+
                            '<a class="btn btn-info" href="{% url 'detail' property_id=x.id %}">See detail</a>'+
                            '</ul>';
        addInfoWindow(marker,contentString);

        {% endfor %}
        {% endfor %}

}
google.maps.event.addDomListener(window, 'load', init);
        </script>

    <script async defer
        src="https://maps.googleapis.com/maps/api/js?key=AIzaSyA5hoIozQlhqeLzU0w9ksjnS7wj3k6ExNU&callback=init">
    </script>
{% endblock %}